import { ClassType } from '@deepkit/core';
import { ClassDecoratorResult, PropertyDecoratorResult, PropertySchema } from '@deepkit/type';
import { ControllerDefinition } from './rpc';
declare class RpcController {
    name?: string;
    definition?: ControllerDefinition<any>;
    actions: Map<string, RpcAction>;
    getPath(): string;
}
declare class RpcAction {
    name?: string;
}
declare class RpcClass {
    t: RpcController;
    controller(nameOrDefinition: string | ControllerDefinition<any>): void;
    addAction(name: string, action: RpcAction): void;
}
export declare const rpcClass: ClassDecoratorResult<typeof RpcClass>;
declare class RpcProperty {
    t: RpcAction;
    onDecorator(classType: ClassType, property: string): void;
    action(): void;
}
export declare const rpcProperty: PropertyDecoratorResult<typeof RpcProperty>;
export declare const rpc: typeof rpcClass & typeof rpcProperty;
export declare function getActionParameters<T>(target: ClassType<T>, method: string): PropertySchema[];
export declare function getActions<T>(target: ClassType<T>): Map<string, RpcAction>;
export {};
